/*
Copyright (c) 2001 Nicolas Roard, Brice Favre, Marie-Charlotte Nguyen

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
/*  Gestion du fichier de configuration du serveur */

#include "configFile.h"

ValueMap ConfigFile::ConfValue;

ConfigFile::ConfigFile (string name)
{
	_filename = name;
}

string ConfigFile::RetrieveValue (string ValueName)
{
	ifstream is(_filename.c_str());
	char * l;
	string res;

	while (is.gets(&l)) {
		string line(l);
		if (ValueName == line.substr(0, ValueName.length())) {
			res = line.substr(ValueName.length()+1, line.length()-(ValueName.length()+1));
		}
	}
	return res;
}

void ConfigFile::RetrieveAll () 
{
	ifstream is(_filename.c_str());
	string name;
	string value;
	string line;
	size_t pos;
	paire *p;

	while (getline(is,line)) {
		if ("#" != line.substr(0,1) && line.length() > 1) {
			pos = line.find("=", 0);
			name = line.substr(0, pos);
			value = line.substr(pos+1, line.length()-(name.length()+1));
			p = new paire(name.c_str(), value);
			ConfValue.insert(ConfValue.end(), *p);
		}
	}

}



