/*
Copyright (c) 2001 Nicolas Roard, Brice Favre, Marie-Charlotte Nguyen

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
#include "projet.h"
#include "webthread.h"

Semaphore SemSocket;

// Options par dfaut
string ServerName = "ITII WebServer";
string ServerVersion = "1.0 Sun-04/11/01";
string ServerPort = "6666";
string HostName = "localhost";
string Server404 = "error404.html";
string ServerRoot = "site/";
string ServerRootCGI = "site/cgi/";
string ServerConf = "conf/";
StrList ServerDefaults;

void config ()
{
	ConfigFile c ("http.conf");
	c.RetrieveAll();
	ServerPort = ConfigFile::ConfValue ["Port"];
	HostName = ConfigFile::ConfValue ["Hostname"];
	Server404 = ConfigFile::ConfValue ["Error404"];
	ServerRoot = ConfigFile::ConfValue["ServerRoot"];
	ServerDefaults.push_back (ConfigFile::ConfValue["DefaultPage"]);
	ServerDefaults.push_back ("index.htm");
}

int main (int argc, char** argv)
{
	config ();
	
	SocketServeur s (atoi(ServerPort.c_str()), true);
	
	cout << "dmarrage du serveur\n";
	
	SemSocket.down (); // on mets le smaphore  0
	while (1) // le serveur tourne en boucle
	{	
		cout << "le main est en attente..." << endl;
		Socket sd = s.accept ();

		WebThread monthread;
		monthread.start ((void*)&sd);
		SemSocket.down (); 
		/* 
		le main est bloqu tant que le thread
		de gestion du client n'a pas remis  1
		le smaphore
		*/
	}

	return 0;
}
