/*
Copyright (c) 2001 Nicolas Roard, Brice Favre, Marie-Charlotte Nguyen

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef __PROJET_H__
#define __PROJET_H__

#include <list>
#include <map>
#include <iterator>
#include "libnet.h"
#include "thread.h"

extern "C"
{
	#include <pthread.h>
}

extern Semaphore SemSocket;

extern string HostName;
extern string ServerName;
extern string ServerVersion;
extern string ServerPort;
extern string Server404;
extern string ServerRoot;
extern string ServerRootCGI;
extern string ServerConf;

typedef list <string> StrList;
extern StrList ServerDefaults;

struct ltstr
{
	bool operator()(string s1, string s2) const
    	{     
		return s1>s2;
	}     
};      

typedef map <string, string, ltstr> ValueMap;
typedef ValueMap::value_type paire;
typedef ValueMap::iterator iter;

#include "configFile.h"

#endif // __PROJET_H__
