/*
Copyright (c) 2001 Nicolas Roard

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include "libnet.h"

SocketClient::SocketClient (string adr, int port, int type = SOCK_STREAM, int protocole = 0)
    : Socket (port, type, protocole)
{
    struct hostent *hp = NULL;
    int longueur = sizeof (struct sockaddr_in);

    hp = gethostbyname (adr.c_str());
    if (hp == NULL) throw EXCEPTION ("gethostbyname");

    memmove(&mAdresse.sin_addr, hp->h_addr, hp->h_length);
            
    struct linger ling;
    ling.l_onoff = 1;
    ling.l_linger = 10;
			            
    setOption (SO_LINGER, &ling, sizeof(ling));
    int ret = connect (mSocket, (sockaddr*) &mAdresse, longueur);
    if (ret == ERREUR) throw EXCEPTION ("connect");

}

SocketClient::SocketClient (const SocketClient& sd) : Socket ( Socket (sd)) {}

SocketClient::SocketClient () : Socket () {}

int SocketClient::getPortDest ()
{
    int ret = -1;
    if (mSocket != SOCKET_CLOSED)
    {
	int len = sizeof (sockaddr_in);
	getsockname (mSocket, (struct sockaddr*)&mAdresseDest, (socklen_t*)&len);
	ret = ntohs (mAdresseDest.sin_port);
    }
    return ret;
}

string SocketClient::getAdresseDest ()
{
    string ret = "INCONNUE";
    if (mSocket != SOCKET_CLOSED)
    {
	int len = sizeof (sockaddr_in);
	getsockname (mSocket, (struct sockaddr*)&mAdresseDest, (socklen_t*)&len);
	ret = inet_ntoa (mAdresseDest.sin_addr);
    }
    return ret;
}

    
