/*
Copyright (c) 2001 Nicolas Roard

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include "libnet.h"

SocketServeur::SocketServeur (int port, bool opt, int type = SOCK_STREAM, int protocole = 0)
    : Socket (port, type, protocole)
{
    int longueur = sizeof (sockaddr_in);

    mAdresse.sin_addr.s_addr = htonl (INADDR_ANY);

    if (opt) setOption (SO_REUSEADDR);

    int opt = 1; 
    int lenopt = sizeof (int);
    cerr << "port : " << port << " port : " << getPort() << " setsockopt : " << setsockopt (mSocket, SOL_SOCKET, SO_REUSEADDR, &opt, lenopt);
    cerr << endl;
    
    
    int ret = bind (mSocket, (sockaddr*) &mAdresse, longueur);
    if (ret == ERREUR) throw EXCEPTION ("bind");

    ret = listen (mSocket, 10);
    if (ret == ERREUR) throw EXCEPTION ("listen");
}

/*
SocketServeur::SocketServeur (int port, int type = SOCK_STREAM, int protocole = 0)
{
    SocketServeur (port, false, type, protocole);
}
*/

SocketServeur::SocketServeur () : Socket () {}

SocketServeur::SocketServeur (Socket sd, bool opt) 
    : Socket (sd)
{
    int longueur = sizeof (sockaddr_in);

    mAdresse.sin_addr.s_addr = htonl (INADDR_ANY);

    if (opt) setOption (SO_REUSEADDR);
    int opt = 1; 
    int lenopt = sizeof (int);
    setsockopt (mSocket, SOL_SOCKET, SO_REUSEADDR, &opt, lenopt);
    

    int ret = bind (mSocket, (sockaddr*) &mAdresse, longueur);
    if (ret == ERREUR) throw EXCEPTION ("bind");

    ret = listen (mSocket, 10);
    if (ret == ERREUR) throw EXCEPTION ("listen");
}

Socket SocketServeur::accept ()
{
    Socket ret;
    struct sockaddr_in adr;
    int longueur = 0;

    longueur = sizeof(sockaddr_in);

    int sd = ::accept (mSocket, (sockaddr*) &adr, (socklen_t*)&longueur);
    if (sd == ERREUR) throw EXCEPTION ("accept");
    ret = Socket (sd, adr);
    
    return ret;
}
